# Class PoseLandmarks

java.lang.Object
com.codename1.ai.vision.PoseLandmarks

public final class PoseLandmarks extends Object

The joint names `Pose.Landmark.getName()` reports, as constants instead of literals. Backends detect different subsets of this list: ML Kit reports the hand and foot detail, Apple Vision reports `NECK` and `ROOT` that ML Kit does not, and a joint the backend did not report is simply absent. Read one through `Pose.getLandmark(String)` and check for `null` rather than assuming a fixed skeleton.

    detector.process(VisionImage.fromCameraFrame(frame)).ready(pose -> {
        Pose.Landmark wrist = pose.getLandmark(PoseLandmarks.RIGHT_WRIST);
        Pose.Landmark shoulder = pose.getLandmark(PoseLandmarks.RIGHT_SHOULDER);
        if (wrist != null && shoulder != null
                && wrist.getConfidence() > 0.6f
                && wrist.getPosition().getY() < shoulder.getPosition().getY()) {
            Log.p("hand raised");
        }
    });

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `LEFT_ANKLE`
  Left ankle.
  `static final String`
  `LEFT_EAR`
  Left ear.
  `static final String`
  `LEFT_ELBOW`
  Left elbow.
  `static final String`
  `LEFT_EYE`
  Center of the left eye.
  `static final String`
  `LEFT_EYE_INNER`
  Inner corner of the left eye.
  `static final String`
  `LEFT_EYE_OUTER`
  Outer corner of the left eye.
  `static final String`
  `LEFT_FOOT_INDEX`
  Ball of the left foot.
  `static final String`
  `LEFT_HEEL`
  Left heel.
  `static final String`
  `LEFT_HIP`
  Left hip.
  `static final String`
  `LEFT_INDEX`
  Left index finger.
  `static final String`
  `LEFT_KNEE`
  Left knee.
  `static final String`
  `LEFT_MOUTH`
  Left corner of the mouth.
  `static final String`
  `LEFT_PINKY`
  Left little finger.
  `static final String`
  `LEFT_SHOULDER`
  Left shoulder.
  `static final String`
  `LEFT_THUMB`
  Left thumb.
  `static final String`
  `LEFT_WRIST`
  Left wrist.
  `static final String`
  `NECK`
  Base of the neck.
  `static final String`
  `NOSE`
  Tip of the nose.
  `static final String`
  `RIGHT_ANKLE`
  Right ankle.
  `static final String`
  `RIGHT_EAR`
  Right ear.
  `static final String`
  `RIGHT_ELBOW`
  Right elbow.
  `static final String`
  `RIGHT_EYE`
  Center of the right eye.
  `static final String`
  `RIGHT_EYE_INNER`
  Inner corner of the right eye.
  `static final String`
  `RIGHT_EYE_OUTER`
  Outer corner of the right eye.
  `static final String`
  `RIGHT_FOOT_INDEX`
  Ball of the right foot.
  `static final String`
  `RIGHT_HEEL`
  Right heel.
  `static final String`
  `RIGHT_HIP`
  Right hip.
  `static final String`
  `RIGHT_INDEX`
  Right index finger.
  `static final String`
  `RIGHT_KNEE`
  Right knee.
  `static final String`
  `RIGHT_MOUTH`
  Right corner of the mouth.
  `static final String`
  `RIGHT_PINKY`
  Right little finger.
  `static final String`
  `RIGHT_SHOULDER`
  Right shoulder.
  `static final String`
  `RIGHT_THUMB`
  Right thumb.
  `static final String`
  `RIGHT_WRIST`
  Right wrist.
  `static final String`
  `ROOT`
  Midpoint between the hips.
  `static final String`
  `UNKNOWN`
  Reported when a backend supplied a joint with no portable name here.

- ## Method Summary

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### NOSE

    public static final String NOSE
    Tip of the nose.
    See Also:
      - Constant Field Values

  - ### LEFT_EYE_INNER

    public static final String LEFT_EYE_INNER
    Inner corner of the left eye.
    See Also:
      - Constant Field Values

  - ### LEFT_EYE

    public static final String LEFT_EYE
    Center of the left eye.
    See Also:
      - Constant Field Values

  - ### LEFT_EYE_OUTER

    public static final String LEFT_EYE_OUTER
    Outer corner of the left eye.
    See Also:
      - Constant Field Values

  - ### RIGHT_EYE_INNER

    public static final String RIGHT_EYE_INNER
    Inner corner of the right eye.
    See Also:
      - Constant Field Values

  - ### RIGHT_EYE

    public static final String RIGHT_EYE
    Center of the right eye.
    See Also:
      - Constant Field Values

  - ### RIGHT_EYE_OUTER

    public static final String RIGHT_EYE_OUTER
    Outer corner of the right eye.
    See Also:
      - Constant Field Values

  - ### LEFT_EAR

    public static final String LEFT_EAR
    Left ear.
    See Also:
      - Constant Field Values

  - ### RIGHT_EAR

    public static final String RIGHT_EAR
    Right ear.
    See Also:
      - Constant Field Values

  - ### LEFT_MOUTH

    public static final String LEFT_MOUTH
    Left corner of the mouth.
    See Also:
      - Constant Field Values

  - ### RIGHT_MOUTH

    public static final String RIGHT_MOUTH
    Right corner of the mouth.
    See Also:
      - Constant Field Values

  - ### NECK

    public static final String NECK
    Base of the neck. Reported by Apple Vision; ML Kit omits it.
    See Also:
      - Constant Field Values

  - ### LEFT_SHOULDER

    public static final String LEFT_SHOULDER
    Left shoulder.
    See Also:
      - Constant Field Values

  - ### RIGHT_SHOULDER

    public static final String RIGHT_SHOULDER
    Right shoulder.
    See Also:
      - Constant Field Values

  - ### LEFT_ELBOW

    public static final String LEFT_ELBOW
    Left elbow.
    See Also:
      - Constant Field Values

  - ### RIGHT_ELBOW

    public static final String RIGHT_ELBOW
    Right elbow.
    See Also:
      - Constant Field Values

  - ### LEFT_WRIST

    public static final String LEFT_WRIST
    Left wrist.
    See Also:
      - Constant Field Values

  - ### RIGHT_WRIST

    public static final String RIGHT_WRIST
    Right wrist.
    See Also:
      - Constant Field Values

  - ### LEFT_PINKY

    public static final String LEFT_PINKY
    Left little finger. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### RIGHT_PINKY

    public static final String RIGHT_PINKY
    Right little finger. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### LEFT_INDEX

    public static final String LEFT_INDEX
    Left index finger. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### RIGHT_INDEX

    public static final String RIGHT_INDEX
    Right index finger. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### LEFT_THUMB

    public static final String LEFT_THUMB
    Left thumb. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### RIGHT_THUMB

    public static final String RIGHT_THUMB
    Right thumb. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### LEFT_HIP

    public static final String LEFT_HIP
    Left hip.
    See Also:
      - Constant Field Values

  - ### RIGHT_HIP

    public static final String RIGHT_HIP
    Right hip.
    See Also:
      - Constant Field Values

  - ### ROOT

    public static final String ROOT
    Midpoint between the hips. Reported by Apple Vision; ML Kit omits it.
    See Also:
      - Constant Field Values

  - ### LEFT_KNEE

    public static final String LEFT_KNEE
    Left knee.
    See Also:
      - Constant Field Values

  - ### RIGHT_KNEE

    public static final String RIGHT_KNEE
    Right knee.
    See Also:
      - Constant Field Values

  - ### LEFT_ANKLE

    public static final String LEFT_ANKLE
    Left ankle.
    See Also:
      - Constant Field Values

  - ### RIGHT_ANKLE

    public static final String RIGHT_ANKLE
    Right ankle.
    See Also:
      - Constant Field Values

  - ### LEFT_HEEL

    public static final String LEFT_HEEL
    Left heel. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### RIGHT_HEEL

    public static final String RIGHT_HEEL
    Right heel. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### LEFT_FOOT_INDEX

    public static final String LEFT_FOOT_INDEX
    Ball of the left foot. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### RIGHT_FOOT_INDEX

    public static final String RIGHT_FOOT_INDEX
    Ball of the right foot. Reported by ML Kit; Apple Vision omits it.
    See Also:
      - Constant Field Values

  - ### UNKNOWN

    public static final String UNKNOWN
    Reported when a backend supplied a joint with no portable name here.
    See Also:
      - Constant Field Values